#!/usr/bin/python
# -*- coding: utf-8 -*-
# Copyright 2014 by trgk.
# All rights reserved.
# This file is part of EUD python library (eudplib), and is released under "MIT License Agreement".
# Please see the LICENSE file that should have been included as part of this package.

from .trigtrg import (
    Condition,
    Action,
    Trigger,
    NoCondition,
    CountdownTimer,
    Command,
    Bring,
    Accumulate,
    Kills,
    CommandMost,
    CommandMostAt,
    MostKills,
    HighestScore,
    MostResources,
    Switch,
    ElapsedTime,
    Briefing,
    Opponents,
    Deaths,
    CommandLeast,
    CommandLeastAt,
    LeastKills,
    LowestScore,
    LeastResources,
    Score,
    Always,
    Never,
    NoAction,
    Victory,
    Defeat,
    PreserveTrigger,
    Wait,
    PauseGame,
    UnpauseGame,
    Transmission,
    PlayWAV,
    DisplayText,
    CenterView,
    CreateUnitWithProperties,
    SetMissionObjectives,
    SetSwitch,
    SetCountdownTimer,
    RunAIScript,
    RunAIScriptAt,
    LeaderBoardControl,
    LeaderBoardControlAt,
    LeaderBoardResources,
    LeaderBoardKills,
    LeaderBoardScore,
    KillUnit,
    KillUnitAt,
    RemoveUnit,
    RemoveUnitAt,
    SetResources,
    SetScore,
    MinimapPing,
    TalkingPortrait,
    MuteUnitSpeech,
    UnMuteUnitSpeech,
    LeaderBoardComputerPlayers,
    LeaderBoardGoalControl,
    LeaderBoardGoalControlAt,
    LeaderBoardGoalResources,
    LeaderBoardGoalKills,
    LeaderBoardGoalScore,
    MoveLocation,
    MoveUnit,
    LeaderBoardGreed,
    SetNextScenario,
    SetDoodadState,
    SetInvincibility,
    CreateUnit,
    SetDeaths,
    Order,
    Comment,
    GiveUnits,
    ModifyUnitHitPoints,
    ModifyUnitEnergy,
    ModifyUnitShields,
    ModifyUnitResourceAmount,
    ModifyUnitHangarCount,
    PauseTimer,
    UnpauseTimer,
    Draw,
    SetAllianceStatus,
    Memory,
    SetMemory,
    DeathsX,
    MemoryX,
    SetDeathsX,
    SetMemoryX,
)

__all__ = (
    "Condition",
    "Action",
    "Trigger",
    "NoCondition",
    "CountdownTimer",
    "Command",
    "Bring",
    "Accumulate",
    "Kills",
    "CommandMost",
    "CommandMostAt",
    "MostKills",
    "HighestScore",
    "MostResources",
    "Switch",
    "ElapsedTime",
    "Briefing",
    "Opponents",
    "Deaths",
    "CommandLeast",
    "CommandLeastAt",
    "LeastKills",
    "LowestScore",
    "LeastResources",
    "Score",
    "Always",
    "Never",
    "NoAction",
    "Victory",
    "Defeat",
    "PreserveTrigger",
    "Wait",
    "PauseGame",
    "UnpauseGame",
    "Transmission",
    "PlayWAV",
    "DisplayText",
    "CenterView",
    "CreateUnitWithProperties",
    "SetMissionObjectives",
    "SetSwitch",
    "SetCountdownTimer",
    "RunAIScript",
    "RunAIScriptAt",
    "LeaderBoardControl",
    "LeaderBoardControlAt",
    "LeaderBoardResources",
    "LeaderBoardKills",
    "LeaderBoardScore",
    "KillUnit",
    "KillUnitAt",
    "RemoveUnit",
    "RemoveUnitAt",
    "SetResources",
    "SetScore",
    "MinimapPing",
    "TalkingPortrait",
    "MuteUnitSpeech",
    "UnMuteUnitSpeech",
    "LeaderBoardComputerPlayers",
    "LeaderBoardGoalControl",
    "LeaderBoardGoalControlAt",
    "LeaderBoardGoalResources",
    "LeaderBoardGoalKills",
    "LeaderBoardGoalScore",
    "MoveLocation",
    "MoveUnit",
    "LeaderBoardGreed",
    "SetNextScenario",
    "SetDoodadState",
    "SetInvincibility",
    "CreateUnit",
    "SetDeaths",
    "Order",
    "Comment",
    "GiveUnits",
    "ModifyUnitHitPoints",
    "ModifyUnitEnergy",
    "ModifyUnitShields",
    "ModifyUnitResourceAmount",
    "ModifyUnitHangarCount",
    "PauseTimer",
    "UnpauseTimer",
    "Draw",
    "SetAllianceStatus",
    "Memory",
    "SetMemory",
    "DeathsX",
    "MemoryX",
    "SetDeathsX",
    "SetMemoryX",
)
